-- Shapeways Calculator V1.1
-- Copyright 2009-2012 Virtox
--	"Notes by Kostadin Kotev 06-2016"
--	To change the price of the Hochschule Mainz Student:
--	Go to line 46 and change the values of:
--	startupCost - Startup field in the UI
--	unitCost - Per CC field in the UI
--	maxSizeX - Maximum Material Dimensions first field
--	maxSizeY - Maximum Material Dimensions second field
--	maxSizeZ - Maximum Material Dimensions third field
--	To change the price of the Hochschule Mainz External:
--	Go to line 58 and change the values of:
--	startupCost - Startup field in the UI
--	unitCost - Per CC field in the UI
--	maxSizeX - Maximum Material Dimensions first field
--	maxSizeY - Maximum Material Dimensions second field
--	maxSizeZ - Maximum Material Dimensions third field


macroscript ShapewaysCalculator
category:"3d printing"
tooltip:"3d printing"
buttonText: "3d printing"
(
global defaultConfig = "[Main]
version=1.1
[Materials]
Hochschule Mainz Student=1
Hochschule Mainz External=2
White Strong & Flexible=3
Colored Strong & Flexible=4
Polished White Strong & Flexible=5
Alumide=6
Detail=7
Frosted Detail=8
Frosted Ultra Detail=9
Black Elasto Plastic=10
Stainless Steel=11
SS Antique Bronze=12
SS Gold Plated =13
Silver=14
Silver Glossy=15
Glazed Ceramics White=16
Glazed Ceramics Black=17
Glazed Ceramics Color=18
Sandstone Full Color=19
Glass Matte =20
Glass Glossy=21
[Hochschule Mainz Student]
materialID=1
startupCost=1.43
unitCost=0.43
maxSizeX=20.0
maxSizeY=20.0
maxSizeZ=25.0
density=1.0
densityDiscount=0.1
discountVolume=20
densityDiscountAmount=0.5
materialInfo=
[Hochschule Mainz External]
materialID=2
startupCost=1.43
unitCost=0.43
maxSizeX=20.0
maxSizeY=20.0
maxSizeZ=25.0
density=1.0
densityDiscount=0.1
discountVolume=20
densityDiscountAmount=0.5
materialInfo=
[White Strong & Flexible]
materialID=3
startupCost=1.50
unitCost=1.40
maxSizeX=350.0
maxSizeY=550.0
maxSizeZ=660.0
density=1.0
densityDiscount=0.1
discountVolume=20
densityDiscountAmount=0.5
materialInfo=white_strong_flexible
[Colored Strong & Flexible]
materialID=4
startupCost=1.75
unitCost=1.75
maxSizeX=180.0
maxSizeY=310.0
maxSizeZ=230.0
density=1.0
materialInfo=white_strong_flexible
[Polished White Strong & Flexible]
materialID=5
startupCost=1.50
unitCost=1.75
maxSizeX=150.0
maxSizeY=150.0
maxSizeZ=150.0
density=1.0
densityDiscount=0.1
discountVolume=20
densityDiscountAmount=0.5
materialInfo=wsfpolished
[Alumide]
materialID=6
startupCost=1.50
unitCost=1.99
maxSizeX=230.0
maxSizeY=180.0
maxSizeZ=310.0
density=1.0
materialInfo=alumide
[Detail]
materialID=7
startupCost=2.50
unitCost=2.99
maxSizeX=250.0
maxSizeY=250.0
maxSizeZ=200.0
density=0.0
materialInfo=white_detail
[Frosted Detail]
materialID=8
startupCost=5.00
unitCost=2.39
maxSizeX=185.0
maxSizeY=203.0
maxSizeZ=298.0
density=3.00
materialInfo=frosted_detail
[Frosted Ultra Detail]
materialID=9
startupCost=5.00
unitCost=3.49
maxSizeX=178.0
maxSizeY=152.0
maxSizeZ=127.0
density=3.00
materialInfo=frosted_detail
[Black Elasto Plastic]
materialID=10
startupCost=3.00
unitCost=2.00
maxSizeX=230.0
maxSizeY=180.0
maxSizeZ=280.0
density=0.00
materialInfo=elasto_plastic
[Stainless Steel]
materialID=11
startupCost=6.00
unitCost=8.00
maxSizeX=450.0
maxSizeY=250.0
maxSizeZ=1000
density=8.07
materialInfo=stainless_steel
[SS Antique Bronze]
materialID=12
startupCost=7.50
unitCost=8.00
maxSizeX=450.0
maxSizeY=250.0
maxSizeZ=1000
density=8.07
materialInfo=stainless_steel
[SS Gold Plated]
materialID=13
startupCost=9.00
unitCost=8.00
maxSizeX=450.0
maxSizeY=250.0
maxSizeZ=1000
density=8.07
materialInfo=stainless_steel
[Silver]
materialID=14
startupCost=30
unitCost=20
maxSizeX=150.0
maxSizeY=150.0
maxSizeZ=30.0
materialInfo=silver
[Silver Glossy]
materialID=15
startupCost=35
unitCost=20
maxSizeX=150.0
maxSizeY=150.0
maxSizeZ=30.0
materialInfo=silver
[Glazed Ceramics White]
materialID=16
startupCost=0.00
unitCost=0.00
areaCost=0.18
maxSizeX=220.0
maxSizeY=170.0
maxSizeZ=300.0
density=2.35
materialInfo=ceramics
[Glazed Ceramics Black]
materialID=17
startupCost=0.00
unitCost=0.00
areaCost=0.19
maxSizeX=220.0
maxSizeY=170.0
maxSizeZ=300.0
density=2.35
materialInfo=ceramics
[Glazed Ceramics Color]
materialID=18
startupCost=0.00
unitCost=0.00
areaCost=0.20
maxSizeX=220.0
maxSizeY=170.0
maxSizeZ=300.0
density=2.35
materialInfo=ceramics
[Sandstone Full Color]
materialID=19
startupCost=3.00
unitCost=0.75
maxSizeX=380.0
maxSizeY=200.0
maxSizeZ=250.0
density=1.94
materialInfo=fullcolor
[Glass Matte]
materialID=20
startupCost=9.00
unitCost=6.00
maxSizeX=75.0
maxSizeY=75.0
maxSizeZ=75.0
density=2.35
materialInfo=milky_white_matte_glass
[Glass Glossy]
materialID=21
startupCost=9.00
unitCost=7.00
maxSizeX=75.0
maxSizeY=75.0
maxSizeZ=75.0
density=2.35
materialInfo=milky_white_matte_glass
[Misc]
defaultMaterial=1
favoriteCurrency=euro
favoriteVAT=0
docking=left
dollar2euro=0.7
vat=19

"

clearListener()
global updateShapewaysValues
global shapewaysTools
global materialList =#()
(
	local theIniFile = getDir #plugcfg + "\\VirTools.ini"
	local statusArray =#()
	local pickedObject=undefined
	local myObject=undefined
	local objectVolume=0
	local objectArea=0
	local docking
	local showDummy = false
	local fixInverted = false
	local debugging = false
	local objectMass=0
	local useEuros = true
	local statusOffset=1
	local savedPosition = [0,0,0]
	local invertedElements=0
	local stillOnLine = false
	local dollar2euro = 1.0--0.6999
	local skipManifold = true
	local ignorePolyWarning = false
	local ignoreSizeWarning = false
	local objectCom = [0,0,0]
	local objectPolyCount =0
	local objectDimensions=#(0,0,0)
	local previousSelection 
	local theMesh
	local defaultMaterial
	local configOK=false
	local objectBoundingVolume=1;
	local objectDensity=0;
	local materialStartup =#(0)
	local materialPrices =#(0)
	local materialInfo=#('')
	local materialName=#("")
	local materialAreaPrices =#(0)
	local materialDimensionsMM =#(point3 0 0 0)
	local densityDiscount=#(1);
	local densityDiscountAmount=#(1);
	local discountVolume=#(30);
	local materialDimensions=#(point3 0 0 0)
	local density = #(0)
	local vat=#(0.0,0.19)
	local triCountLimit=1000000
	local statusLines=6
	local withinLimits=true
	local mainLink = "http://www.shapeways.com/materials/"

	local aboutRO, objectRO, objectPropertiesRO, materialRO,materialPropertiesRO, cawRO, pricingRO, tweakingRO
	local geometryFilter, unifiedPrint, localizedRead, localizedPrint, reStatus, updateStatus, findElements, manifoldCheck,calculateVolume,calculatePrice,polyCheck,displayPrice,updatePrices,checkDimensions,calculateIt, unifiedRead, unifiedReadA,currencyFix,updateMaterials,selectMaterial,loadMaterial

	fn updateShapewaysValues = (
		materialsId = loadMaterial()
		selectMaterial(materialsId)
		updateMaterials materialRO.lstMaterialType.selection
		updatePrices materialsId pricingRO.vatType.selection
	)

	fn selectMaterial materialsId = (
		materialRO.lstMaterialType.selection=materialsId
	)
	
fn loadConfig = (
	updateStatus("  Loading config")
	configOK=false;

	local configPresent = (hasINISetting theIniFile "Main")
--	print configPresent
	if (configPresent) then (
		versionNr = getIniSetting theIniFile "Main" "version" as float;
		if (versionNr != 1.1) then (
			configPresent=false
		)
	)
	
	if (not configPresent) then (
		updateStatus("    Incompatible/No config not found")
		updateStatus("    Creating default");
		myConfig = fopen theIniFile "w+b"
		mySucces = WriteString myConfig defaultConfig
		fclose myConfig
		if (mySucces) then (
				updateStatus ("    Default config created");
		) else (
				updateStatus ("    Failed to create config");
		)
	)
	
	if (hasINISetting theIniFile "Materials") then (
		materialList = getIniSetting theIniFile "Materials"
--		print materialList
		updateStatus ("  Found " + materialList.count as string +" materials")
		if materialList.count > 0 then (
			materialRO.lstMaterialType.items = materialList
			for j = 1 to materialList.count do (
				currentMaterial = materialList[j]
				i = getIniSetting theIniFile currentMaterial "materialID" as integer
				if (i < 1) then (
					i=j+20
				)
--				print currentMaterial
--				print i
--				print "\n"
				if i == 1 or i == 2 then
				(
					materialName[i] = "Materials on Shapeways.com"
				)
				else
				(
					materialName[i] = currentMaterial
				)
				materialStartup[i]  = getIniSetting theIniFile currentMaterial "startupCost" as float
				materialPrices[i] = getIniSetting theIniFile currentMaterial "unitCost" as float
				materialAreaPrices[i] = getIniSetting theIniFile currentMaterial "areaCost" as float
				local mmx = getIniSetting theIniFile currentMaterial "maxSizeX" as float
				local mmy = getIniSetting theIniFile currentMaterial "maxSizeY" as float
				local mmz = getIniSetting theIniFile currentMaterial "maxSizeZ" as float
				materialDimensionsMM[i]= (point3 mmx mmy mmz)
				density[i]  = getIniSetting theIniFile currentMaterial "density" as float
				densityDiscount[i]  = getIniSetting theIniFile currentMaterial "densityDiscount" as float
				discountVolume[i]  = getIniSetting theIniFile currentMaterial "discountVolume" as float
				densityDiscountAmount[i]  = getIniSetting theIniFile currentMaterial "densityDiscountAmount" as float
				materialInfo[i] = getIniSetting theIniFile currentMaterial "materialInfo"  as string 
			)
		)
		if hasINISetting theIniFile "Misc" then (
			miscList = getIniSetting theIniFile "Misc"
			defaultMaterial = getIniSetting theIniFile "Misc" "defaultMaterial" as float
			dollar2euro = getIniSetting theIniFile "Misc" "dollar2euro" as float
			docking = getIniSetting theIniFile "Misc" "docking"
		)
		updateStatus("  Config ok")
		configOK=true;
	)
)

fn restoreConfig = (
	updateStatus("Restoring config")
	myConfig = fopen theIniFile "w+b"
	mySucces = WriteString myConfig defaultConfig
	FCLose myConfig
	if (mySucces) then (
			updateStatus ("Default config restored");
	) else (
			updateStatus ("Failed to restore ini");
	)
	loadConfig()
)
	fn currencyFix myValue = (
		local myString = formattedPrint myValue format:".2f";
		myValue = myString as float;
		return myValue;
	)


	if (formattedPrint ==undefined) then (
		fn formattedPrint value format:"" = (
			return print value as string
		)
	)

	if (substituteString ==undefined) then (
		fn substituteString inputV findV replaceV = (
			local i = findString inputV findV
			if i == undefined then return inputV
			replace inputV i findV.count replaceV
		)
	)

	fn geometryFilter obj = superClassOf obj == GeometryClass

	fn unifiedPrint myValue = (
		if myValue == undefined then myValue =0
		units.formatValue (myValue)
	) 
	
	fn unifiedRead myString = (
		if myString == undefined then myValue = " "
		units.decodeValue (myString)
	)

	fn unifiedReadA myArray = (
		local newArray =#()
		for i =1 to myArray.count do (
			local j=[0,0,0]
			p=myArray[i]
			j.x =units.decodeValue (p.x as string + "mm") -- internal uses mm
			j.y =units.decodeValue (p.y as string + "mm")
			j.z =units.decodeValue (p.z as string + "mm")
			append newArray j
		)
		return newArray
	)

	
	fn localizedRead myString = (
		local myString = substituteString myString "$" ""
		myString = substituteString myString "" ""
		local myValue = myString as float
		if myValue == undefined do myValue =0
		if (useEuros) then (
			myValue = myValue/dollar2euro
		)
		return myValue
	)

	fn localizedPrint myValue = (
		if myValue == undefined then myValue =0
		if (useEuros) then (
			myCurrency = ""
			myValue =myValue * dollar2euro
		) else (
			myCurrency = "$"
		)
		local myString = formattedPrint myValue format:".2f"
		return (myCurrency + " "+ myString)
	)	

	fn reStatus a = (
		if (statusArray.count ==0) then (
			return 0
		)
		local s = 1+((statusOffset/(cawRO.statusSlider.range.y))*(statusArray.count-statusLines)) as Integer
		if (s > statusArray.count-statusLines) then (
			s = statusArray.count-statusLines
		)
		if (s<1) then (
			s=1
		)
		local myDisplay=""
		for i = s to statusArray.count do (
			myDisplay = myDisplay + statusArray[i]
		)
		cawRO.statusDisplay.caption = myDisplay
	)
		
	fn updateStatus myString noNewLine:false = (
		if (debugging) then(
			print myString
		)
		if (noNewLine) then (
			myString += " "
			if (stillOnLine) then (
				statusArray[statusArray.count] += myString
			) else (
				append statusArray myString
			)
			stillOnLine = true
		) else (
			myString += "\n"
			if (stillOnLine) then (
				statusArray[statusArray.count] += myString;
				stillOnLine = false
			) else (
				append statusArray myString
			)
		)
		
		while(statusArray.count >256) do (
			statusArray = deleteItem statusArray 1
		)
		local r = statusArray.count-statusLines as integer
		if r<2 then r=2
			
		statusOffset=r
		cawRO.statusSlider.range=[1,r,1]
		cawRO.statusSlider.ticks = r-2
		reStatus 1
	)

	fn findElements theMesh = (

		updateStatus "  Finding shells :" noNewLine:true
		cawRO.prgCalculation.value = 0

		-- Array to store elements
		local Elements = #()
		-- Array containing all face indices
		local Faces = #{1..theMesh.numFaces} as array
		local totalCount = Faces.count
		-- Loop until nothing left in 'Faces' array
		while Faces.count > 0 do
		(
			
			-- Get the element using the first face in the 'Faces' array
			local FaceElem = meshOp.getElementsUsingFace theMesh Faces[1]
			
			-- Subtract the element from the 'Faces' array
			Faces = ((Faces as bitArray) - FaceElem) as array
			
			pj= 100.0-100.0 * Faces.count/totalCount
			cawRO.prgCalculation.value=pj
			
			-- Append the elements
			append Elements FaceElem
		)
		
		updateStatus (Elements.count as string)
		-- 'Elements' now contains an array of bitarrays
		Elements
	)

	fn oneElements theMesh = (
	-- Array to store elements
		local Elements = #()
		-- Array containing all face indices
		local Faces = #{1..theMesh.numFaces} as array
		
		append Elements Faces
		
		-- 'Elements' now contains an array of bitarrays
		Elements
	)
	
		
	fn manifoldCheck theMesh =	(
		updateStatus "  Manifold :" noNewLine:true

		local start = timeStamp()
		
		openEdges =#{}
		sharedEdges = #{}
		local numFaces = theMesh.numfaces 
		cawRO.prgCalculation.value = 0

		for i = 1 to numFaces do (
			pj= 100.0 * i/numFaces
			if (mod pj 1 == 0) do (
				cawRO.prgCalculation.value=pj
			)

			local edgeBarray = meshop.getEdgesUsingFace theMesh #{i}
			
			local vertexBarray = meshop.getVertsUsingFace theMesh #{i}
			
			for v in vertexBarray do (
				local myBEdges = meshop.getEdgesUsingVert theMesh #{v}
				local myEdges = myBEdges as array
			)
				
			
			for e in edgeBarray do ( -- usually 3 items !!
				local myVertices = meshop.getVertsUsingEdge theMesh #{e}
				local myArray = (myVertices as array)
				local myEdgeA = meshop.getEdgesUsingVert theMesh myArray[1]
				local myEdgeB = meshop.getEdgesUsingVert theMesh myArray[2]
				local myEdges = myEdgeA*myEdgeB -- INTERSECTION !!

				local myFaces = meshop.getFacesUsingEdge theMesh myEdges
			
				faceList = myFaces as array
				local ulc= faceList.count
				if ulc == 1 then ( -- open edge
					append openEdges e
				)
				if ulc ==3 then ( --shared edge, possible ?
					append sharedEdges e
				)
			)
		)
		local end = timeStamp()
		mt = ((end - start) / 1000.0) as string + " seconds"

		cawRO.prgCalculation.value = 0
		nrOfOpenEdges = (openEdges as array).count 
		nrOfSharedEdges = (sharedEdges as array).count 
		if (nrOfOpenEdges==0 and nrOfSharedEdges==0) then (
			updateStatus( "Ok: "+mt)
			return true
		) else (
			updateStatus( "NO: "+mt)
			updateStatus ("      Number of open edges : "+ (nrOfOpenEdges as string))
			updateStatus ("      Number of shared edges : "+ (nrOfSharedEdges as string))
			updateStatus( "Aborted !")
			theMesh.selectedEdges = openEdges+sharedEdges
			return false
		)
	)

					

		
	fn calculateVolume theMesh = (
	-- function from Max help file, adapted to add a progress bar
		local Volume= 0.0
		local MyArea =0.0
		local Center= [0.0, 0.0, 0.0] 
		local xDim =0.0
		local xMin =1000000000.0
		local xMax =-1000000000.0
		local yDim =0.0
		local yMin =1000000000.0
		local yMax =-1000000000.0
		local zDim =0.0
		local zMin =1000000000.0
		local zMax =-1000000000.0

		local start = timeStamp()

		local Elements
		if (fixInverted) then (
			Elements = findElements theMesh
		) else (
			Elements = oneElements theMesh
		)
		
		local j=0
		invertedElements =0
		local numFaces = theMesh.numfaces 		
		elementCount = Elements.count
		local e=0;

		for objectElement in Elements do (
			local elementCenter=point3 0.0 0.0 0.0
			local elementVolume=0
			local elementArea=0;
			e=e+1
			cawRO.prgCalculation.value = 0
			local elementString = "  Volume " + (e as string) + "/" + (elementCount as string)  + " :"
			updateStatus elementString noNewLine:true
			for i  in objectElement do	( 
				pj= 100.0 * j/numFaces
				j=j+1
				if (mod pj 1 == 0) do (
					cawRO.prgCalculation.value=pj
				)
				local Face= getFace theMesh i 
				
				
--				local dA = meshop.getFaceArea theMesh #{i}
				dA=0.0;
				local vert2 = getVert theMesh Face.z 
				local vert1 = getVert theMesh Face.y 
				local vert0 = getVert theMesh Face.x 

				
				
				xMin = amin xMin vert0.x vert1.x vert2.x
				xMax = amax xMax vert0.x vert1.x vert2.x
				yMin = amin yMin vert0.y vert1.y vert2.y
				yMax = amax yMax vert0.y vert1.y vert2.y
				zMin = amin zMin vert0.z vert1.z vert2.z
				zMax = amax zMax vert0.z vert1.z vert2.z
		
				local dV = Dot (Cross (vert1 - vert0) (vert2 - vert0)) vert0
				local dA = 0.5*length (Cross (vert1 - vert0) (vert2 - vert0))
				elementCenter+= (vert0 + vert1 + vert2) * dV 
				elementVolume+= dV 
				elementArea+=dA
			) 
			if fixInverted and elementVolume < 0 then (
				elementVolume = -elementVolume
				elementCenter = -elementCenter
				updateStatus (" Inverted, flipping")
				invertedElements += 1
			) else (
				if (bit.isNAN elementVolume) then(
					updateStatus (" Invalid volume ! ")
					elementVolume = 0
					elementCenter = [0,0,0]

				) else (
					updateStatus (" Ok")
				)
			)
			MyArea += elementArea
			Volume += elementVolume
			Center += elementCenter
		)
		Volume /= 6.0
		Center /= 24.0
		Center /= Volume 
		xDim=xMax-xMin
		yDim=yMax-yMin
		zDim=zMax-zMin
		cawRO.prgCalculation.value= 0.0

		local cm = "1.0CM"
		local cmPerUnit = 1/units.decodeValue cm
		CCperCubicUnit = cmPerUnit*cmPerUnit*cmPerUnit
		local CM2perCubicUnit = cmPerUnit*cmPerUnit

		Volume = Volume*CCperCubicUnit
		 MyArea=MyArea*CM2perCubicUnit
		local MyBoundingVolume = xDim * yDim * zDim*CCperCubicUnit
		
		local MyDensity = Volume/myBoundingVolume
		

		local end = timeStamp()
		mt = ((end - start) / 1000.0) as string + " seconds"
		updateStatus( "  Time: "+mt)		
		#(Volume,MyArea,Center,myBoundingVolume,myDensity,xDim,yDim,zDim)
	)


	fn calculatePrice myVolume myArea myBoundingvolume myDensity materialsId vatId =	(
--		myVolume = currencyFix(myVolume)
		
		local PriceEx=0;

		if (materialPrices[materialsId] >0.0) then (
			PriceEx = PriceEx + materialPrices[materialsId]*myVolume
		)

		if (materialAreaPrices[materialsId] >0.0) then (
			PriceEx = PriceEx + materialAreaPrices[materialsId]*myArea
		)
		if (myDensity >0) then (
			updateStatus ("  Density: "+(myDensity) as string)
		)

		if (densityDiscount[materialsId]<1.0 and densityDiscount[materialsId]>0.0) then (
			if (myDensity>densityDiscount[materialsId]) then (
				if (myVolume > discountVolume[materialsId]) then (
					updateStatus "  Volume density discount!" 
					PriceEx = materialPrices[materialsId]*discountVolume[materialsId]
					PriceEx = PriceEx + 	densityDiscountAmount[materialsId]*materialPrices[materialsId]*(myVolume-discountVolume[materialsId])
				)
			)
		)
		PriceEx = PriceEx + materialStartup[materialsId]
		PriceEx = currencyFix(PriceEx)

		local sPrice = PriceEx * (tweakingRO.scaleFactor.value/100.0)^3
		local tPrice =  localizedRead tweakingRO.targetPrice.text


		local tScale
		if tPrice == undefined then ( tScale =100 ) else (
			tScale = 100.0*(tPrice/PriceEx)^0.33
		)
		local VATv = vat[vatId]*PriceEx
		VATv = currencyFix (VATv)
		local PriceIn = PriceEx + VATv
--		PriceIn = currencyFix(PriceIn)

		local Markup
		local propertyIndex = fileProperties.findProperty #custom "ShapewaysMarkup";
		if ( propertyIndex>0 ) then (
			Markup = fileProperties.getPropertyValue #custom propertyIndex
		) else (
			Markup = localizedRead pricingRO.priceMarkUp.text 
		)


		
		local MarkupVAT = Markup * vat[vatId]
		MarkupVAT = currencyFix(MarkupVAT)
		local TotalPrice = PriceIn + Markup + MarkupVAT
		#(PriceEx,VATv,PriceIn,Markup,MarkupVAT,TotalPrice,sPrice,tScale)
	)	

	fn polyCheck theMesh = (
		local triCount = theMesh.numfaces 
		objectPropertiesRO.txtObjectPolyCount.text = formattedPrint triCount format:"i"
		if  triCount > triCountLimit then (
			difval = triCount - triCountLimit
			updateStatus ("  Polygon count : FALSE (" + triCount as string + ")") 
			return false
		) else (
			if (triCount > 10000) then (
				updateStatus ("  Polygon count : OK (" + triCount as string +")")
			) else (
				updateStatus ("  Polygon count : OK (" + triCount as string +")")
			)
			return true
		)
	)
		
	fn displayPrice myPrices =	(
		pricingRO.priceEx.text = localizedPrint myPrices[1]
		pricingRO.priceVAT.text = localizedPrint myPrices[2]
		pricingRO.priceIn.text = localizedPrint myPrices[3]
		pricingRO.priceMarkup.text = localizedPrint myPrices[4]
		pricingRO.priceMarkupVAT.text = localizedPrint myPrices[5]
		pricingRO.totalPrice.text = localizedPrint myPrices[6]
		tweakingRO.scalePrice.text = localizedPrint myPrices[7]
		tweakingRO.targetScale.text = formattedPrint myPrices[8] format:".2f" + "%"

		targetPrice = localizedRead tweakingRO.targetPrice.text
		tweakingRO.targetPrice.text = localizedPrint targetPrice
	)
		
	fn updatePrices materialsId vatId = (
		local myPrices = #()
		myPrices = calculatePrice objectVolume objectArea objectBoundingVolume objectDensity materialsId vatId
		displayPrice myPrices
		objectMass = objectVolume * density[materialsId]
		objectPropertiesRO.txtObjectMass.text = formattedPrint objectMass format:".2f gr"
	)

	fn checkDimensions materialId = (
		myMaterialDimensions = #(materialDimensions[materialId].x,materialDimensions[materialId].y,materialDimensions[materialId].z)
		sort objectDimensions
		sort myMaterialDimensions
		updateStatus "  Testing object size :" noNewLine:true 
		if (objectDimensions[1]>myMaterialDimensions[1] or objectDimensions[2]>myMaterialDimensions[2] or objectDimensions[3]>myMaterialDimensions[3] ) then (
			updateStatus (" Too Big")
			updateStatus ("    Object dimensions:")
			updateStatus ("   " + objectDimensions[3] as string + " / " + objectDimensions[2] as string + " / " + objectDimensions[1] as string);
			updateStatus ("    Material dimensions:")
			updateStatus ("   " + myMaterialDimensions[3] as string+ " / " + myMaterialDimensions[2] as string+ " / " + myMaterialDimensions[1] as string);
			return false
		) else (
			updateStatus ("  OK ")
			return true
		)
	)


	fn calculateIt = (
						
		if statusArray.count> 0 then (
			updateStatus ("")
		)
		updateStatus ("Start calculation")

		myObject =undefined

		if  not $DummyObjectShowingErrors == undefined and not previousSelection == undefined  then (
			if $ == $DummyObjectShowingErrors  then (
				select previousSelection
			)
		)

		if (objectRO.btnPickObject.state == on) then (
			myObject = pickedObject;
		)
		if (objectRO.btnSelectedObject.state == on) then (
			myObject = $;
		)
		if myObject == undefined then (
			messagebox "Please pick or select an object first"
		) else (

--			print myObject
--			if group or multiple the nweld here
/*			
--			if (
			myArray = myObject as array;
			if (myArray.count >1) then (
				print myArray
				newtheMesh = snapshot myArray[1]
				for i =2 to myArray.count do (
						attach newMesh myArray[i]
				)
			)
			myObject = newMesh
			*/
			if (isValidNode myObject) then (

 			 if (canConvertTo myObject Mesh) then (
				updateStatus ("Using '" +myObject.name + "'")

				if (isValidNode $DummyObjectShowingErrors) then (
					savedPosition =  $DummyObjectShowingErrors.position
					delete $DummyObjectShowingErrors
				)	
		
				theMesh = snapshot myObject
				theMesh.name = "DummyObjectShowingErrors"
				theMesh.position = savedPosition

				withinLimits = true;
				if (not ignoreSizeWarning) then (
					objectDimensions[1]=theMesh.max.x-theMesh.min.x
					objectDimensions[2]=theMesh.max.y-theMesh.min.y
					objectDimensions[3]=theMesh.max.z-theMesh.min.z
					withinLimits = checkDimensions materialRO.lstMaterialType.selection
				)
				if (withinLimits) then (
					if (polyCheck(theMesh) or ignorePolyWarning) then (
						if (skipManifold or manifoldCheck(theMesh)) then (

							myObjectDimensions = calculateVolume(theMesh)



							objectVolume = myObjectDimensions[1]
							objectArea = myObjectDimensions[2]
							objectCom = myObjectDimensions[3]-theMesh.position
							objectBoundingVolume=myObjectDimensions[4]
							objectDensity=myObjectDimensions[5]
							objectMass = objectVolume*density[materialRO.lstMaterialType.selection]
							objectDimensions = deleteItem myObjectDimensions 1
							objectDimensions = deleteItem myObjectDimensions 1
							objectDimensions = deleteItem myObjectDimensions 1
							objectDimensions = deleteItem myObjectDimensions 1
							objectDimensions = deleteItem myObjectDimensions 1
							objectPropertiesRO.txtObjectVolume.text = formattedPrint objectVolume format:".2f cc"
							objectPropertiesRO.txtObjectArea.text = formattedPrint objectArea format:".2f cm2"
							objectPropertiesRO.txtObjectComX.text = unifiedPrint objectCom.x
							objectPropertiesRO.txtObjectComY.text = unifiedPrint objectCom.y
							objectPropertiesRO.txtObjectComZ.text = unifiedPrint objectCom.z
							objectPropertiesRO.txtObjectDimensionX.text = unifiedPrint objectDimensions[1]
							objectPropertiesRO.txtObjectDimensionY.text = unifiedPrint objectDimensions[2]
							objectPropertiesRO.txtObjectDimensionZ.text = unifiedPrint objectDimensions[3]
							objectPropertiesRO.txtObjectDimensionDensity.text = formattedPrint (100*objectDensity) format:".2f%%"
							objectPropertiesRO.txtObjectDimensionTotal.text = unifiedPrint (objectDimensions[1]+objectDimensions[2]+objectDimensions[3])


							-- moved to updatePrices ivm densities !! -- objectPropertiesRO.txtObjectMass.text = formattedPrint objectMass format:".2f gr"
							updatePrices materialRO.lstMaterialType.selection pricingRO.vatType.selection
							delete $DummyObjectShowingErrors
						)
					)
				)
			) else (
				updateStatus "Input is not convertible to mesh ?"
			)
		 ) else (
				updateStatus "Don't know how to treat input!"
		 )
		)
		if  not showDummy then (
			if (isValidNode $DummyObjectShowingErrors) then (
				delete $DummyObjectShowingErrors
			)
		) else (
			previousSelection = getCurrentSelection()
			select $DummyObjectShowingErrors
			max modify mode
			subobjectLevel = 2
		)
		updateStatus ("Done")
	)

	fn loadMaterial = (
		local propertyIndex = fileProperties.findProperty #custom "ShapewaysMaterial"
		if ( propertyIndex>0 ) then (
			materialsId = fileProperties.getPropertyValue #custom propertyIndex
		) else (
			materialsId = defaultMaterial
		)
		return materialsId
	)
	
	fn updateMaterials materialsId = (
		
		materialDimensions = unifiedReadA(materialDimensionsMM)
		materialPropertiesRO.txtMaterialPrice.text = localizedPrint materialPrices[materialsId]
		materialPropertiesRO.txtMaterialAreaPrice.text = localizedPrint materialAreaPrices[materialsId]
		materialPropertiesRO.txtMaterialStartup.text = localizedPrint materialStartup[materialsId]
		materialPropertiesRO.txtMaterialDimensionX.text = unifiedPrint materialDimensions[materialsId].x
		materialPropertiesRO.txtMaterialDimensionY.text = unifiedPrint materialDimensions[materialsId].y
		materialPropertiesRO.txtMaterialDimensionZ.text = unifiedPrint materialDimensions[materialsId].z
		materialPropertiesRO.txtMaterialInfo.text= materialName[materialsId] + " @ Shapeways"
		materialPropertiesRO.txtMaterialInfo.address= mainLink + materialInfo[materialsId]
	)
	
	rollout aboutRO "About, Info & Disclaimer"	(
		Group "About" (
			edittext A1 height:100 width:210 readOnly:true align:#left labelOnTop:true
			text:" Shapeways Calculator v1.1\n\n  - Calculates the Shapeways price.\n  - Tests for several common errors.\n  - Price tweaking tools.\n\n Created by Virtox, 2009/2010/2011"		)

		Group "Info" (
			Label A2a " For information on Shapeways : " align:#left
			HyperLink shapeways "http://www.shapeways.com/" address:"http://www.shapeways.com/" color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 192) align:#left offset:[10,0]
			Label A2b " For information on Virtox : " align:#left
			HyperLink homepage "http://www.virtox.net/" address:"http://www.virtox.net/scripts/max/shapeways_calculator/" color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 192) align:#left  offset:[10,0]
		)
		
		Group "Disclaimer" (
			Label A3a " This is only an indicative tool." align:#left
			Label A3b " Please enjoy at your own risk." align:#left
		)
	)

	rollout objectRO "Object selection" (
		checkbutton btnSelectedObject "Selected object" align:#left across:2 width:100 checked:true tooltip:"The tool will use the current selected object"
		checkbutton btnPickObject "Pick object"  width:100 align:#right message:"Right-click this button to pick your object" tooltip:"Click this button to pick an object from the scene."

		on btnSelectedObject changed state do 	(
			if state == on then ( -- chosen selected object
				btnPickObject.state=off -- turn other button off
				btnSelectedObject.tooltip = "The tool will use the current selected object"

				if pickedObject == undefined then (
					btnPickObject.tooltip = "Click this button to pick an object from the scene"
				) else (
					btnPickObject.tooltip = "Enable this button to use this object from the scene"
				)

			) else (
				if pickedObject == undefined then (
					btnPickObject.state=off
					btnSelectedObject.state=on
					btnPickObject.tooltip = "Click this button to pick an object from the scene"
					btnSelectedObject.tooltip = "The tool will use the current selected object"
				) else (
					btnPickObject.state=on
					btnSelectedObject.tooltip = "Enable this button to use the current selection"
					btnPickObject.tooltip = "The tool will use this object from the scene, right-click this button to pick a different object from the scene"
				)
			)
		)
		
		on btnPickObject changed state do 	(
			if state ==on then ( -- chosen picked object

				-- in case none was picked yet :
				if pickedObject == undefined then (
					obj=selectByName title:"Please pick your object" buttonText:"PICK" showHidden:true single:true filter:geometryFilter forceListenerFocus:false
					if obj != undefined then (
						pickedObject = obj 
						btnPickObject.text = obj.name
					) else (
						btnPickObject.text = "Pick object"
					)
				)

				if pickedObject == undefined then (
					btnPickObject.state=off
					btnSelectedObject.state=on
					btnPickObject.tooltip = "Click this button to pick an object from the scene"
				) else (
					btnSelectedObject.state=off
					btnSelectedObject.tooltip = "Enable this button to use the current selection"
					btnPickObject.tooltip = "The tool will use this object from the scene, right-click this button to pick a different object from the scene"
				)
			) else (
				btnSelectedObject.state=on
				btnSelectedObject.tooltip = "The tool will use the current selected object"

				if pickedObject == undefined then (
					btnPickObject.tooltip = "Click this button to pick an object from the scene"
				) else (
					btnPickObject.tooltip = "Enable this button to use this object from the scene"
				)
			)
		)
		
		on btnPickObject rightclick do (
			obj=selectByName title:"Please pick your object" buttonText:"PICK" showHidden:true single:true filter:geometryFilter forceListenerFocus:false
			if obj != undefined then (
				pickedObject = obj 
				btnPickObject.text = obj.name
				btnPickObject.tooltip = "The tool will use this object from the scene, right-click this button to pick a different object from the scene"
				btnPickObject.state=on
				btnSelectedObject.state=off
				btnSelectedObject.tooltip = "Enable this button to use the current selection"
			) else (
				btnPickObject.text = "Pick object"
				btnPickObject.state=off
				btnSelectedObject.state=on
				btnPickObject.tooltip = "Click this button to pick an object from the scene"
			)
		)
	)

	rollout objectPropertiesRO "Object Properties" (
		label B1 "Object Volume:" width:150 across:2 align:#left
		edittext txtObjectVolume text:(formattedPrint objectVolume format:".2f cc") align:#right readOnly:true fieldwidth:66

		label B1b "Surface Area:" width:150 across:2 align:#left
		edittext txtObjectArea text:(formattedPrint objectArea format:".2f cm2") align:#right readOnly:true fieldwidth:66

		label B2 "Polygon count:" width:150 across:2 align:#left
		edittext txtObjectPolyCount "" text:(formattedPrint objectPolyCount format:"i") align:#right readOnly:true fieldwidth:66

		label B3 "Mass:" width:150 across:2 align:#left
		edittext txtObjectMass text:(formattedPrint objectMass format:".2f gr") align:#right readOnly:true fieldwidth: 66

		label B4 "Center of mass, relative to pivot:" width:200 across:1 align:#left
		edittext txtObjectComX text:(unifiedPrint 0.00) across:3 fieldwidth:66 readOnly:true align:#right
		edittext txtObjectComY text:(unifiedPrint 0.00) fieldwidth:66 readOnly:true  align:#right
		edittext txtObjectComZ text:(unifiedPrint 0.00) fieldwidth:66 readOnly:true align:#right
		
		label B5 "Bounding dimensions:" width:200 across:1 align:#left
		edittext txtObjectDimensionX text:(unifiedPrint 0.00) across:3 fieldwidth:66 readOnly:true align:#right labelOnTop:true
		edittext txtObjectDimensionY text:(unifiedPrint 0.00) fieldwidth:66 readOnly:true align:#right  labelOnTop:true
		edittext txtObjectDimensionZ text:(unifiedPrint 0.00) fieldwidth:66 readOnly:true align:#right  labelOnTop:true

		label B6 "Bounding Box Sum:" width:200 across:2 align:#left
		edittext txtObjectDimensionTotal text:(unifiedPrint 0.00) fieldwidth:66 readOnly:true align:#right  labelOnTop:true

		label B7 "Object Density:" width:200 across:2 align:#left
		edittext txtObjectDimensionDensity text:(formattedPrint objectDensity format:"0.1f%%") fieldwidth:66 readOnly:true align:#right labelOnTop:true

	)

	rollout materialRO  "Material Selection" (
		dropdownList  lstMaterialType  width:210 align:#right items:#("empty") selection:1
		
		on lstMaterialType selected materialsId do 
		(
			if (objectVolume == undefined and objectArea == undefined) then (
				txtMaterialPrice.text = ""
				txtMaterialAreaPrice.text = ""
				txtStartupPrice.text = ""
			) else (
				local propertyIndex = fileProperties.findProperty #custom "ShapewaysMaterial";
				if ( propertyIndex>0 ) then (
					fileProperties.deleteProperty #custom "ShapewaysMaterial"
				)
				fileProperties.addProperty #Custom "ShapewaysMaterial" materialsId
				updateMaterials materialsId
				updatePrices materialsId pricingRO.vatType.selection
--				checkDimensions materialsId
			)
		)	
		
	)

	rollout materialPropertiesRO "Material Properties" (
		label C0 " Startup" width:66  align:#left across:3
		label C1 " Per CC" width:66  
		label C1b " Per CM2" width:66  
		edittext txtMaterialStartup text:(localizedPrint materialStartup[materialRO.lstMaterialType.selection]) align:#left readOnly:true fieldwidth:66 across:3
		edittext txtMaterialPrice text:(localizedPrint materialPrices[materialRO.lstMaterialType.selection]) align:#right readOnly:true fieldwidth:66
		edittext txtMaterialAreaPrice text:(localizedPrint materialAreaPrices[materialRO.lstMaterialType.selection]) align:#right readOnly:true fieldwidth:66
		
		label C2 "Maximum material dimensions" width:200 across:1 align:#left
		edittext txtMaterialDimensionX text:(unifiedPrint materialDimensions[materialRO.lstMaterialType.selection].x) across:3 fieldwidth:66 readOnly:true align:#right
		edittext txtMaterialDimensionY text:(unifiedPrint materialDimensions[materialRO.lstMaterialType.selection].y) fieldwidth:66 readOnly:true align:#right
		edittext txtMaterialDimensionZ text:(unifiedPrint materialDimensions[materialRO.lstMaterialType.selection].z) fieldwidth:66 readOnly:true align:#right

		label C3 "More material info" width:200 across:1 align:#left
		HyperLink txtMaterialInfo mainLink address:mainLink color:(color 127 127 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 192) align:#left offset:[10,0]

			
	)

	rollout cawRO "Calculate" (

		button btnCalculate "Calculate" enabled:true across:2 align:#left width:70
		progressBar prgCalculation height:21 width:136 align:#right

		on btnCalculate pressed do (
			calculateIt()
		)
--MAYBE		label U1 "System Unit " width:150  align:#left across:2
--MAYBE		edittext sysUnit text:(unifiedPrint 1.0) align:#right readOnly:true fieldwidth:66

--MAYBE		label U2 "Display Unit " width:150  align:#left across:2
--MAYBE		edittext dispUnit text:(units.DisplayType) align:#right readOnly:true fieldwidth:66
		
--		label statusTop "^" width:20 height:20 align:#left across:3
		local myh = 18*6
		slider statusSlider " " width:20  align:#left orient:#vertical ticks:0 range:[1,2,1] type:#integer across:2
		label statusDisplay "" width:180 height:myh readOnly:true align:#right style_sunkenedge:true offset:[0,5]

		on statusSlider changed myValue do ( 
			statusOffset = statusSlider.range.y-myValue
			reStatus 1
		)
	)
	
	rollout settingsRO "Settings" (
		checkbox skipManifoldCheck "Skip manifold check" checked:skipManifold
		checkbox showObjectOnErrorCheck "Show dummy if errors" checked:showDummy
		checkbox fixInvertedCheck "Flip inverted objects in calculation" checked:fixInverted
		checkbox debuggingCheck "Debugging" checked:debugging

		checkbox ignorePolyWarningCheck "Ignore polygon count" checked:ignorePolyWarning
		checkbox ignoreSizeWarningCheck "Ignore size warnings" checked:ignoreSizeWarning		on fixInvertedCheck changed testValue do (fixInverted =testvalue)
		on debuggingCheck changed testValue do (debugging =testvalue)
		on skipManifoldCheck changed testValue do (skipManifold =testvalue)
		on showObjectOnErrorCheck changed testValue do (showDummy =testvalue)
		on ignorePolyWarningCheck changed testValue do (ignorePolyWarning =testvalue)
		on ignoreSizeWarningCheck changed testValue do (ignoreSizeWarning =testvalue)
	)

	rollout pricingRO "Pricing"	(
		label bla "Volume price:" align:#left
		label bla1 " Ex VAT" width:66 align:#left across:3
		label bla2 " VAT" width:66 align:#left across:3
		label bla3 " Inc VAT" width:66 align:#left across:3
		
		edittext priceEx  text:"" across:3 readOnly:true fieldwidth:66 align:#left
		edittext priceVAT text:"" readOnly:true fieldwidth:66
		edittext priceIn  text:"" readOnly:true fieldwidth:66 align:#right

		label blab "Your markup:" align:#left
		label bla4 " Ex VAT" width:66 across:3 align:#left
		label bla6 " VAT" width:66 
		label bla5 " Retail" width:66 align:#right

		edittext priceMarkup  text:"" align:#right fieldwidth:66 across:3
		edittext priceMarkupVAT  text:"" align:#right fieldwidth:66 readOnly:true
		edittext totalPrice  text:"" fieldwidth:66 align:#right readOnly:true

		dropdownList  currencyType  width:75 align:#left across:2 items:#("Euro ()", "Dollar ($)")  selection:1
		dropdownList  vatType  width:125 align:#right across:2 items:#("no VAT", "VAT EU 19%")  selection:2

		on priceMarkup entered markupString do 
		(
			local Markup = localizedRead pricingRO.priceMarkUp.text 
			local propertyIndex = fileProperties.findProperty #custom "ShapewaysMarkup";
			if ( propertyIndex>0 ) then (
				fileProperties.deleteProperty #custom "ShapewaysMarkup"
			)
			fileProperties.addProperty #Custom "ShapewaysMarkup" Markup
			updatePrices materialRO.lstMaterialType.selection vatType.selection
		)


		on vatType selected vatId do 
		(
			if (objectVolume == undefined and objectArea == undefined) then (
				txtMaterialPrice.text = "";
				txtMaterialAreaPrice.text = "";
				txtMaterialStartup.text = "";
			) else (
				updatePrices materialRO.lstMaterialType.selection vatType.selection
			)
		)

		on currencyType selected currencyId do 
		(
			local Markup = localizedRead pricingRO.priceMarkUp.text 
			if currencyId == 1 then 
			(
				useEuros = true
			) 
			else 
			(
				useEuros=false
			)
			pricingRO.priceMarkup.text = localizedPrint Markup
			if (objectVolume == undefined and objectArea == undefined) then 
			(
				txtMaterialPrice.text = "";
				txtMaterialAreaPrice.text = "";
				txtMaterialStartup.text = "";
			) 
			else
			(
				updateMaterials materialRO.lstMaterialType.selection
				updatePrices materialRO.lstMaterialType.selection vatType.selection
			)
		)
	)

	rollout testButtons "Restore Config?" 
		(
		label ays "WARNING"
		label aysb ""
		label ays2 "Are you sure you wish to overwrite config file with the default values?"
		label ays3 ""
		button theYesButton "Yes" width:120 across:2
		button theNoButton "No" width:120
		on theYesButton pressed do (
			RestoreConfig()
			destroyDialog testButtons
		)
		on theNoButton pressed do (
			destroyDialog testButtons
		)
	)

	
	rollout configRO "Config" (
		button btnLoadC "Load" enabled:true align:#left across:3 width:70
		button btnEditC "Edit" enabled:true align:#left width:70
		button btnRestoreC "Restore" enabled:true align:#left width:70

		on btnLoadC pressed do (
			LoadConfig()
		)
		on btnEditC pressed do (
			edit theIniFile
		)
		on btnRestoreC pressed do (
			createDialog testButtons 320 120
		)
	)

	rollout tweakingRO "Price tweaking"	(
		Group "Scale by price"
		(
			label tp "Limit price ex VAT to " width:134 across:2 align:#left
			edittext targetPrice  text:"0.00" fieldwidth:66 align:#right
			label ts "Then scale to " width:134 align:#left across:2
			edittext targetScale text:"0%" fieldwidth:66 align:#right readOnly:true
	--TODO			button btnScaleTarget "Scale Now" align:#left

		)
		
		Group "Price by scale"
		(
				label sca  "If scaled to " width:134 across:2 align:#left
				spinner scaleFactor "%" range:[0.0,1000.0,100.0] type:#float fieldwidth:56 align:#right
				label sp "Then price ex VAT is " width:134 align:#left across:2
				edittext scalePrice text: "0.00" fieldwidth:66 align:#right readOnly:true
	--TODO 		button btnScale "Scale Now" align:#left
		)
		
		on targetPrice entered instring do (
			updatePrices materialRO.lstMaterialType.selection pricingRO.vatType.selection
		)

		on scaleFactor changed ins do (
			updatePrices materialRO.lstMaterialType.selection pricingRO.vatType.selection
		)
	)


-- 	try(cui.UnRegisterDialogBar shapewaysTools) catch()
	try(closeRolloutFloater shapewaysTools) catch()

	shapewaysTools = newrolloutfloater "Shapeways Calculator" 250 700

	updateStatus("Shapeways Calculator v1.1");
	addrollout objectRO shapewaysTools rolledup:false
	addrollout cawRO shapewaysTools rolledup:false
	addrollout pricingRO shapewaysTools
	addrollout objectpropertiesRO shapewaysTools
	addrollout materialRO shapewaysTools
	addrollout materialPropertiesRO shapewaysTools
	addrollout tweakingRO shapewaysTools rolledup:true
	addrollout configRO shapewaysTools rolledup:true
	addrollout aboutRO shapewaysTools rolledup:true
	
-- 	cui.RegisterDialogBar shapewaysTools style:#(#cui_dock_vert,#cui_floatable,#cui_handles)

	callbacks.removeScripts id:#shapewaysSettings
	callbacks.addScript #filePostOpen  "updateShapewaysValues()" id:#shapewaysSettings
	
	callbacks.removeScripts id:#shutdowncalculator
-- 	callbacks.addScript #preSystemShutdown "try(cui.UnRegisterDialogBar shapewaysTools) catch(); try(closeRolloutFloater shapewaysTools) catch()" id:#shutdowncalculator
	callbacks.addScript #preSystemShutdown "try(closeRolloutFloater shapewaysTools) catch()" id:#shutdowncalculator


	updateStatus ("  Interface ok")
	loadConfig()
	if (configOK) then 
	(
		updateShapewaysValues()
-- 		if (docking == "left") then 
-- 		(
-- 			cui.DockDialogBar shapewaysTools #cui_dock_left
-- 		)
-- 		if (docking == "right") then 
-- 		(
-- 			cui.DockDialogBar shapewaysTools #cui_dock_right
-- 		)
	)	
	updateStatus ("Ready")
)
)